"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var _pathToRegex = _interopRequireDefault(require("path-to-regex"));

var RoutesMap = function (_Map) {
  (0, _inherits2.default)(RoutesMap, _Map);

  function RoutesMap() {
    (0, _classCallCheck2.default)(this, RoutesMap);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(RoutesMap).apply(this, arguments));
  }

  (0, _createClass2.default)(RoutesMap, [{
    key: "get",
    value: function get(key) {
      var resultList = [];
      if (this.has(key)) return (0, _get2.default)((0, _getPrototypeOf2.default)(RoutesMap.prototype), "get", this).call(this, key);
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.keys()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var path = _step.value;
          var parser = new _pathToRegex.default(path);
          var result = parser.match(key);

          if (result) {
            resultList.push(path);
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      if (resultList.length === 0) {
        return undefined;
      }

      var match = (0, _get2.default)((0, _getPrototypeOf2.default)(RoutesMap.prototype), "get", this).call(this, resultList[0]);

      if (resultList.length > 1) {
        console.log("You have multiple route that match \"".concat(key, "\" in your configuration\n       Please verify your configuration:\n       \n       ").concat(JSON.stringify(resultList, null, 2), "\n       \n       We have selected the first match ").concat(JSON.stringify(match, null, 2), "\n       \n       You can ask support by opening a new issue: https://github.com/yeutech-lab/react-router-dom-utils/issues/new \n       "));
      }

      return match;
    }
  }]);
  return RoutesMap;
}((0, _wrapNativeSuper2.default)(Map));

exports.default = RoutesMap;
module.exports = exports.default;