"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _makeRoutes = _interopRequireDefault(require("../makeRoutes"));

var _matchParamsPath = _interopRequireDefault(require("../matchParamsPath"));

var Link = function (_React$Component) {
  (0, _inherits2.default)(Link, _React$Component);

  function Link() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, Link);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(Link)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "onMouseOver", function (e, routes, routesMap) {
      e.preventDefault();
      e.stopPropagation();
      var _this$props = _this.props,
          to = _this$props.to,
          onMouseOver = _this$props.onMouseOver,
          onPreload = _this$props.onPreload,
          onLoaded = _this$props.onLoaded,
          preload = _this$props.preload;

      var component = _this.getComponent(to, routes, routesMap);

      if (onMouseOver) {
        onMouseOver();
      }

      if (preload && component && component.preload) {
        if (onPreload) {
          onPreload(e);
        }

        component.preload().then(function () {
          if (onLoaded) {
            onLoaded(e);
          }
        });
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "onClick", function (e, routes, routesMap) {
      e.preventDefault();
      e.stopPropagation();
      var _this$props2 = _this.props,
          to = _this$props2.to,
          preload = _this$props2.preload,
          onClick = _this$props2.onClick,
          onPreload = _this$props2.onPreload,
          onLoaded = _this$props2.onLoaded,
          waitChunk = _this$props2.waitChunk;

      var component = _this.getComponent(to, routes, routesMap);

      if (onClick) {
        onClick(e);
      }

      if (preload && waitChunk && component && component.preload) {
        if (onPreload) {
          onPreload(e);
        }

        component.preload().then(function () {
          if (onLoaded) {
            onLoaded(e);
          }

          _this.changePage(e, to);
        });
        return;
      }

      _this.changePage(e, to);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "changePage", function (e, path) {
      var _this$props3 = _this.props,
          history = _this$props3.history,
          push = _this$props3.push,
          delay = _this$props3.delay,
          onPageChange = _this$props3.onPageChange,
          onBeforePageChange = _this$props3.onBeforePageChange;
      var timeout = delay === 0 ? function (cb) {
        return cb();
      } : setTimeout;
      var ms = typeof delay === 'function' ? delay() : delay;

      if (onBeforePageChange) {
        onBeforePageChange(e);
      }

      timeout(function () {
        if (onPageChange) {
          onPageChange(e);
        }

        if (push) {
          push(path);
        } else {
          history.push(path);
        }
      }, ms);
    });
    return _this;
  }

  (0, _createClass2.default)(Link, [{
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      var _this$props4 = this.props,
          routes = _this$props4.routes,
          routesMap = _this$props4.routesMap,
          ContextConsumer = _this$props4.ContextConsumer;

      if ((routes.length || routesMap.size) && ContextConsumer && process.env.NODE_ENV !== 'production') {
        console.warn('You passed routes and/or routesMap and ContextConsumer props. It will skip routes and routesMap and use the ContextConsumer to retrieve them from the context.');
      }
    }
  }, {
    key: "getComponent",
    value: function getComponent(path) {
      var routes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var routesMap = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new Map();
      var component;
      var inMap = routesMap.get(path);

      if (inMap && inMap.component) {
        return inMap.component;
      }

      var list = [Array.from(routesMap.values()), routes];

      for (var i = 0; i < list.length; i += 1) {
        if (list[i].length) {
          var res = (0, _makeRoutes.default)(list[i]).filter(function (route) {
            var dest = route.props.path;

            if (!dest) {
              return false;
            }

            if (dest === path) {
              return true;
            }

            return (0, _matchParamsPath.default)(path, dest);
          });

          if (res.length) {
            var exitLoop = false;

            for (var j = 0; j < res.length; j += 1) {
              if (res[j].props.component) {
                component = res[j].props.component;
                exitLoop = true;
                break;
              }
            }

            if (exitLoop) {
              break;
            }
          }
        }
      }

      return component;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props5 = this.props,
          Tag = _this$props5.tag,
          to = _this$props5.to,
          routes = _this$props5.routes,
          routesMap = _this$props5.routesMap,
          ContextConsumer = _this$props5.ContextConsumer,
          delay = _this$props5.delay,
          preload = _this$props5.preload,
          match = _this$props5.match,
          location = _this$props5.location,
          history = _this$props5.history,
          onClick = _this$props5.onClick,
          onPreload = _this$props5.onPreload,
          onPageChange = _this$props5.onPageChange,
          onLoaded = _this$props5.onLoaded,
          onMouseOver = _this$props5.onMouseOver,
          staticContext = _this$props5.staticContext,
          waitChunk = _this$props5.waitChunk,
          onBeforePageChange = _this$props5.onBeforePageChange,
          push = _this$props5.push,
          rest = (0, _objectWithoutProperties2.default)(_this$props5, ["tag", "to", "routes", "routesMap", "ContextConsumer", "delay", "preload", "match", "location", "history", "onClick", "onPreload", "onPageChange", "onLoaded", "onMouseOver", "staticContext", "waitChunk", "onBeforePageChange", "push"]);
      return ContextConsumer ? _react.default.createElement(ContextConsumer, null, function (_ref) {
        var contextRoutes = _ref.routes,
            contextRoutesMap = _ref.routesMap;
        return _react.default.createElement(Tag, (0, _extends2.default)({
          onClick: function onClick(e) {
            return _this2.onClick(e, contextRoutes, contextRoutesMap);
          },
          onFocus: function onFocus(e) {
            return _this2.onMouseOver(e, contextRoutes, contextRoutesMap);
          },
          onMouseOver: function onMouseOver(e) {
            return _this2.onMouseOver(e, contextRoutes, contextRoutesMap);
          },
          href: to
        }, rest));
      }) : _react.default.createElement(Tag, (0, _extends2.default)({
        onClick: function onClick(e) {
          return _this2.onClick(e, routes, routesMap);
        },
        onFocus: function onFocus(e) {
          return _this2.onMouseOver(e, routes, routesMap);
        },
        onMouseOver: function onMouseOver(e) {
          return _this2.onMouseOver(e, routes, routesMap);
        },
        href: to
      }, rest));
    }
  }]);
  return Link;
}(_react.default.Component);

exports.default = Link;
(0, _defineProperty2.default)(Link, "propTypes", {
  to: _propTypes.default.string.isRequired,
  tag: _propTypes.default.any,
  delay: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.func]),
  preload: _propTypes.default.bool,
  onClick: _propTypes.default.func,
  onPageChange: _propTypes.default.func,
  onPreload: _propTypes.default.func,
  onLoaded: _propTypes.default.func,
  onMouseOver: _propTypes.default.func,
  onBeforePageChange: _propTypes.default.func,
  waitChunk: _propTypes.default.bool,
  routes: _propTypes.default.array,
  routesMap: _propTypes.default.instanceOf(Map),
  ContextConsumer: _propTypes.default.any,
  match: _propTypes.default.object,
  location: _propTypes.default.object,
  history: _propTypes.default.object,
  push: _propTypes.default.func
});
(0, _defineProperty2.default)(Link, "defaultProps", {
  tag: 'a',
  delay: 0,
  waitChunk: false,
  preload: true,
  onClick: null,
  onBeforePageChange: null,
  onPageChange: null,
  onPreload: null,
  onLoaded: null,
  onMouseOver: null,
  routes: [],
  routesMap: new Map(),
  ContextConsumer: null,
  match: undefined,
  location: undefined,
  history: undefined,
  push: undefined
});
module.exports = exports.default;