"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _matchParamsPath = _interopRequireDefault(require("../matchParamsPath"));

describe('matchParamsPath', function () {
  it('should match', function () {
    expect((0, _matchParamsPath.default)('/users/1', '/users/:id')).toBe(true);
    expect((0, _matchParamsPath.default)('/users/1/settings', '/users/:id/settings')).toBe(true);
    expect((0, _matchParamsPath.default)('/users/1/settings/2', '/users/:id/settings/:settingsId')).toBe(true);
    expect((0, _matchParamsPath.default)('/users/1/settings/2/ok', '/users/:id/settings/:settingsId/:w1th-d4sh')).toBe(true);
  });
  it('should fail', function () {
    expect((0, _matchParamsPath.default)('/users', '/users/:id')).toBe(false);
    expect((0, _matchParamsPath.default)('/users/settings', '/users/:id/settings')).toBe(false);
    expect((0, _matchParamsPath.default)('/users/1/settings', '/users/:id/settings/:settingsId')).toBe(false);
    expect((0, _matchParamsPath.default)('/users/1/settings/ok', '/users/:id/settings/:settingsId/:w1th-d4sh')).toBe(false);
  });
});